(*
 * (c) Andreas Rossberg 1999-2007
 *
 * Standard ML state
 *
 * Definition, Section 6.3
 *
 * Notes:
 *   - Memory gets represented by references. This avoids expanding out all
 *     occurances of the state convention in the inference rules.
 *   - Since exception names are generated by stamps we do not really need the
 *     exception name set. We maintain it anyway.
 *)

structure State :> STATE =
struct
    (* Import *)

    type Addr		= DynamicObjectsCore.Addr
    type ExName		= DynamicObjectsCore.ExName
    type Val		= DynamicObjectsCore.Val
    type State		= DynamicObjectsCore.State


    (* Operations *)

    fun insertAddr  ((mem,ens), a, v) = ( AddrMap.insert(mem, a, v), ens )
    fun insertExName((mem,ens), en)   = ( mem, ExNameSet.add(ens, en) )

    fun findAddr((mem,ens), a) = AddrMap.find(mem, a)
end;
